﻿Public Class NewGame

    Public newStats As New StatsBar
    Public newExperienceBar As New ExperienceBar
    Public InGameBlocks As New Generic.List(Of ColourBlock)
    Public newActionBar As New ActionBar


    Public DeathTime As New Timer

    Public originalLocation As Point
    Public currentMousePoint As Point
    Public locationDifference_X As Integer
    Public locationDifference_Y As Integer

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FormDragTimer.Tick
        Me.Location = New Point(MousePosition.X + locationDifference_X, MousePosition.Y + locationDifference_Y)

    End Sub

    Private Sub title_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Titlebar.MouseDown
        originalLocation = Me.Location
        currentMousePoint = MousePosition

        locationDifference_Y = originalLocation.Y - currentMousePoint.Y
        locationDifference_X = originalLocation.X - currentMousePoint.X

        FormDragTimer.Enabled = True

    End Sub

    Private Sub title_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Titlebar.MouseUp
        FormDragTimer.Enabled = False

    End Sub

    Private Sub btnExit_MouseEnter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.MouseEnter
        btnExit.BackgroundImage = My.Resources.EXIT_hover

    End Sub

    Private Sub btnExit_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnExit.MouseDown
        btnExit.BackgroundImage = My.Resources.EXIT_clicked

    End Sub

    Private Sub btnExit_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.MouseLeave
        btnExit.BackgroundImage = My.Resources._EXIT

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Close()
    End Sub

    Private Sub cmbGameMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbGameMode.SelectedIndexChanged
        If cmbGameMode.SelectedItem = "Survival" Then
            TimerInfo.Visible = False
            FrequencyInfo.Visible = False
        ElseIf cmbGameMode.SelectedItem = "Timed" Then
            TimerInfo.Visible = True
            FrequencyInfo.Visible = False
        ElseIf cmbGameMode.SelectedItem = "Sudden Death" Then
            TimerInfo.Visible = False
            FrequencyInfo.Visible = True
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Close()

    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        If cmbGameMode.SelectedItem = Nothing Then
            MsgBox("Please select a game mode.", MsgBoxStyle.Exclamation)
        ElseIf cmbGameMode.SelectedItem = "Survival" Then
            MainForm.GameContainer.BackColor = Color.White
            MainForm.GameContainer.Controls.Clear()
            newStats.Dock = DockStyle.Top
            newExperienceBar.Dock = DockStyle.Bottom
            newActionBar.Dock = DockStyle.Bottom
            newExperienceBar.lblTimer.Visible = False
            MainForm.MenuContainer.Enabled = False
            MainForm.AccessControl.Controls.Remove(newStats)
            MainForm.AccessControl.Controls.Add(newStats)
            MainForm.AccessControl.Controls.Remove(newExperienceBar)
            MainForm.AccessControl.Controls.Add(newExperienceBar)

            MainForm.AccessControl.Controls.Remove(newActionBar)
            MainForm.AccessControl.Controls.Add(newActionBar)


            MainForm.GameTimer.Interval = 10
            MainForm.GameTimer.Enabled = True

            newStats.UpdateValues()
            newExperienceBar.UpdateValues()



            Close()
        ElseIf cmbGameMode.SelectedItem = "Timed" Then
            MainForm.GameContainer.BackColor = Color.White
            MainForm.GameContainer.Controls.Clear()
            Dim min As Integer = nupMinutes.Value
            Dim sec As Integer = nupSeconds.Value
            MainForm.sec = nupSeconds.Value
            MainForm.min = nupMinutes.Value
            If min > 10 Then
                If sec > 10 Then
                    newExperienceBar.lblTimer.Text = min & ":" & sec
                Else
                    newExperienceBar.lblTimer.Text = min & ":" & "0" & sec
                End If

            Else
                If sec > 10 Then
                    newExperienceBar.lblTimer.Text = "0" & min & ":" & sec
                Else
                    newExperienceBar.lblTimer.Text = "0" & min & ":" & "0" & sec
                End If
            End If
            newStats.Dock = DockStyle.Top
            newExperienceBar.Dock = DockStyle.Bottom
            newActionBar.Dock = DockStyle.Bottom
            newExperienceBar.lblTimer.Visible = True
            MainForm.MenuContainer.Enabled = False
            MainForm.AccessControl.Controls.Remove(newStats)
            MainForm.AccessControl.Controls.Add(newStats)
            MainForm.AccessControl.Controls.Remove(newExperienceBar)
            MainForm.AccessControl.Controls.Add(newExperienceBar)

            MainForm.AccessControl.Controls.Remove(newActionBar)
            MainForm.AccessControl.Controls.Add(newActionBar)

            MainForm.GameTimer.Interval = 10
            MainForm.GameTimer.Enabled = True
            MainForm.CountdownTimer.Enabled = True

            newStats.UpdateValues()
            newExperienceBar.UpdateValues()



            Close()

        ElseIf cmbGameMode.SelectedItem = "Sudden Death" Then
            Dim continueExecution As Boolean
            If cbFrequency.SelectedItem = Nothing Then
                MsgBox("You must select a frequency.", MsgBoxStyle.Exclamation)
            ElseIf cbFrequency.SelectedItem = "Low (Easy)" Then
                continueExecution = True
                MainForm.DeathTimer.Interval = 60000
            ElseIf cbFrequency.SelectedItem = "Normal (Moderate)" Then
                continueExecution = True
                MainForm.DeathTimer.Interval = 40000
            ElseIf cbFrequency.SelectedItem = "High (Challenging)" Then
                continueExecution = True
                MainForm.DeathTimer.Interval = 20000
            End If

            If continueExecution = True Then
                MainForm.GameContainer.BackColor = Color.White
                MainForm.GameContainer.Controls.Clear()
                newStats.Dock = DockStyle.Top
                newExperienceBar.Dock = DockStyle.Bottom
                newActionBar.Dock = DockStyle.Bottom
                newExperienceBar.lblTimer.Visible = False
                MainForm.MenuContainer.Enabled = False
                MainForm.AccessControl.Controls.Remove(newStats)
                MainForm.AccessControl.Controls.Add(newStats)
                MainForm.AccessControl.Controls.Remove(newExperienceBar)
                MainForm.AccessControl.Controls.Add(newExperienceBar)
                MainForm.AccessControl.Controls.Remove(newActionBar)
                MainForm.AccessControl.Controls.Add(newActionBar)

                MainForm.GameTimer.Interval = 10
                MainForm.DeathTimer.Enabled = True
                MainForm.GameTimer.Enabled = True

                newStats.UpdateValues()
                newExperienceBar.UpdateValues()



                Close()


        End If

        End If


    End Sub

    Public Sub AddNewBlock()
        Dim difference_X As Integer = MainForm.GameContainer.Width - 48
        Dim difference_Y As Integer = MainForm.GameContainer.Height - 48
        Dim newBlock As New ColourBlock
        Dim r As New Random
        Dim i As Integer
        i = r.Next(1, 4)
        Select Case i
            Case 1
                newBlock.BackColor = Color.Red
            Case 2
                newBlock.BackColor = Color.Green
            Case 3
                newBlock.BackColor = Color.Blue
        End Select


        Dim ii As New Random
        Dim x As Integer
        Dim y As Integer
        x = ii.Next(0, difference_X)
        y = ii.Next(0, difference_Y)

        newBlock.Location = New Point(x, y)

        InGameBlocks.Add(newBlock)
        For Each block In InGameBlocks
            MainForm.GameContainer.Controls.Add(block)

        Next



    End Sub


    Public Sub AddDeathBlock()
        Dim difference_X As Integer = MainForm.GameContainer.Width - 48
        Dim difference_Y As Integer = MainForm.GameContainer.Height - 48
        Dim newBlock As New ColourBlock
        newBlock.BackColor = Color.Black

        Dim ii As New Random
        Dim x As Integer
        Dim y As Integer
        x = ii.Next(0, difference_X)
        y = ii.Next(0, difference_Y)

        newBlock.Location = New Point(x, y)

        InGameBlocks.Add(newBlock)
        For Each block In InGameBlocks
            MainForm.GameContainer.Controls.Add(block)

        Next

        If cbFrequency.SelectedItem = "Low (Easy)" Then
            DeathTime.Interval = 15000
        ElseIf cbFrequency.SelectedItem = "Normal (Moderate)" Then
            DeathTime.Interval = 11000
        ElseIf cbFrequency.SelectedItem = "High (Challenging)" Then
            DeathTime.Interval = 7000
        End If
        DeathTime.Enabled = True

        AddHandler DeathTime.Tick, AddressOf DeathTimer

    End Sub

    Public Sub DeathTimer()
        MainForm.myHealthValue = 0
        newStats.UpdateValues()
    End Sub

End Class